//--------------------------------------------------------------------

#include "Headers/SelectFunc.H"

//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

extern void Error(char *Message)
{
	MessageBox (GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

extern int CleanUp(int Kill, int Delete)
{
	if(Working_File)fclose(Working_File);
	if(CypherTemp_File)fclose(CypherTemp_File);
	if(EncryptTemp_File)fclose(EncryptTemp_File);
	if(Source_File)fclose(Source_File);
	if(Target_File)fclose(Target_File);

	Header[0] = '\0';
	Temp[0] = '\0';
	Key[0] = '\0';
	Char_Buffer = '\0';
	KeyLeinght = 0;
	LoopCount = 0;
	End_Of_File = 0;
	if(Delete)
	{
		unlink(EncryptTemp);
		unlink(CypherTemp);
	}
	if(Kill)
	{
		unlink(EncryptTemp);
		unlink(CypherTemp);
		unlink(FileToChangeTemp);
		unlink(PackBackupTemp);
		exit(0);
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int Encrypted(char *FileToCheck)
{
	static FILE * FileToCheck_File;
	if(FileToCheck_File)fclose(FileToCheck_File);
	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 14.");

	LoopCount = 0;
	End_Of_File = 0;
	Header[0] = '\0';

	while (End_Of_File != EOF)
	{
		End_Of_File = fscanf(FileToCheck_File, "%c", &Char_Buffer);
		LoopCount++;
		if(LoopCount < 11)
			sprintf(Header,"%s%s",Header,&Char_Buffer);
		if(LoopCount == 11)
		{
			if(strcmp(Header,"Encrypted~") == 0)
			{
				if(FileToCheck_File)
					fclose(FileToCheck_File);
				End_Of_File = 0;
				return 1;
			}

			if(strcmp(Header,"128Packed~") == 0)
			{
				if(FileToCheck_File)
					fclose(FileToCheck_File);
				End_Of_File = 0;
				return 2;
			}
			break;
		}
	}
	if(FileToCheck_File)
		fclose(FileToCheck_File);
	End_Of_File = 0;
	return 3;
}

//////////////////////////////////////////////////////////////////////

void RemoveFlag(char *FileToChange)
{
	LoopCount = 0;
	FILE *FileToChange_File , *FileToChangeTemp_File;
	if((FileToChange_File = fopen(FileToChange,"rb")) == NULL)
		Error("Could Not Open Source For Read.	Error: 15.");
	if((FileToChangeTemp_File = fopen(FileToChangeTemp,"wb")) == NULL)
		Error("Could Not Open Source For Read. Error: 16.");
	while (End_Of_File != EOF)
	{
		End_Of_File = fscanf(FileToChange_File, "%c", &Char_Buffer);
		LoopCount++;
		if(LoopCount > 10 && End_Of_File != EOF)
		{
			fprintf(FileToChangeTemp_File, "%c", Char_Buffer);
		}
	}
	if(FileToChangeTemp_File)
		fclose(FileToChangeTemp_File);
	if(FileToChange_File)
		fclose(FileToChange_File);
	End_Of_File = 0;
}

//////////////////////////////////////////////////////////////////////

extern int SetTempVariables()
{
	sprintf(EncryptTemp,"%s\\%s",GetTempDirectory(),"EncryptTemp.128G");
	sprintf(CypherTemp,"%s\\%s",GetTempDirectory(),"CypherTemp.128G");
	sprintf(FileToChangeTemp,"%s\\%s",GetTempDirectory(),"FileChangeTemp.128G");
	sprintf(PackBackupTemp,"%s\\%s",GetTempDirectory(),"PackBackupTemp.128G");
	if(!EncryptTemp)
		return 1;
	if(!CypherTemp)
		return 1;
	if(!FileToChangeTemp)
		return 1;
	if(!PackBackupTemp)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int OpenFileDialog (HWND hWnd, char *zCaption, char *zFilespec, char *zInitialDir, char *zFilter, char *zDefExtension, int Flags)
{
	static	OPENFILENAME  ofn;
	static char File[2048];
	static char FileTitle[2048];
	static char Filter[2048];
	static char InitialDir[2048];
	static char Title[100];
	static char DefExt[2048];
	static int RetFlg;
	if(strlen(zInitialDir)==0)
	{
		sprintf(InitialDir,"%s",CurDir());
	}
	sprintf(Filter,"%s",zFilter);
	sprintf(InitialDir,"%s",zInitialDir);
	sprintf(File,"%s",zFilespec);
	sprintf(DefExt,"%s",zDefExtension);
	sprintf(Title,"%s",zCaption);
	ofn.lStructSize=sizeof(ofn);
	ofn.hwndOwner=hWnd;
	ofn.lpstrFilter=Filter;
	ofn.nFilterIndex=1;
	ofn.lpstrFile=File;
	ofn.nMaxFile=sizeof(File);
	ofn.lpstrFileTitle=FileTitle;
	ofn.nMaxFileTitle=sizeof(FileTitle);
	ofn.lpstrInitialDir=InitialDir;
	ofn.Flags=Flags;
	ofn.lpstrDefExt=DefExt;
	ofn.Flags = 527372;
	if(strlen(Title)>0)
	{
		ofn.lpstrTitle=Title;
	}
	RetFlg=GetOpenFileName(&ofn);
	sprintf(zFilespec,"%s",File);
	Flags=ofn.Flags;
	return RetFlg;
}

//////////////////////////////////////////////////////////////////////

extern char *CurDir (void)
{
	static int StrCnt;
	LPSTR StrFunc [16];
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	GetCurrentDirectory (1024,StrFunc[StrCnt]);
	return StrFunc[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern int CharInt(char *string2convert)
{
	int i, lenght_string;
	int power;
	int tmp_number;
	char tmp_char;
	if (!string2convert)
	{
		string2convert = "0";
		Error("Character To Interger Conversion Error. Error: 17.");
		return -1;
	}
	lenght_string = strlen(string2convert);
	for(i = 0; i < (lenght_string / 2); i++)
	{
		tmp_char = string2convert[i];
		string2convert[i] = string2convert[lenght_string - 1 - i];
		string2convert[lenght_string - 1 - i] = tmp_char;
	}
	power = 1;
	i = 0;
	tmp_number = 0;
	while (string2convert[i] != '\0')
	{
		tmp_number += (string2convert[i] - '0') * power;
		power *= 10;
		i++;
	}
	return tmp_number;
}

/////////////////////////////////////////////////////////////////////

extern char *StringScan (char *S, int length1, int length2)
{
	static int LocalLoop1;
	static int LocalLoop2;
	static char StrFunction[64][257];
	static int StrCnt;
	LocalLoop1 = 0;
	LocalLoop2 = 0;
	while(LocalLoop1 < 64)
	{
		while(LocalLoop2 < 257)
		{
			StrFunction[LocalLoop1][LocalLoop2] = '\0';
			LocalLoop2++;
		}
		LocalLoop1++;
	}
	if(++StrCnt==64) StrCnt = 0;
	strncpy(StrFunction[StrCnt], &S[length1], length2);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern char *GetTempDirectory(void)
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char T [257];
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	LPSTR StrFunc [16];
	static int	 StrCnt;
	static int T;
	static char Buffer[2048];
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,Buffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",Buffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static	RECT  wRect;
	static	DWORD  x;
	static	DWORD  y;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern short FileEmpty(char *File2Size)
{
	FILE *fp;
	static short size;
	size = 0;

	if((fp = fopen(File2Size,"r+b")) == NULL)
	{
		Error("Could Not Open Source For Read. Error 18.");
		return 0;
	}

	while(!feof(fp))
	{
		fgetc(fp);
		if(!feof(fp))
		{
			size++;
		}

		if(size > 0)
		{
			if(fp)fclose(fp);
			return 0;
		}

		if(ferror(fp))
		{
			Error("Error Sizing File. Error 19.");
			return 0;
		}
	}

	if(fp)fclose(fp);
	if(size == 0)return 1;
	return 0;
}

/////////////////////////////////////////////////////////////////////

extern char *CreateKey(void)
{
	static char xCodedKey[27];
	sprintf(xCodedKey,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",49,50,56,71,97,109,109,97,126,69,110,99,114,121,112,116,101,100);
	return xCodedKey;
}

/////////////////////////////////////////////////////////////////////

extern int EncryptProcess(void)
{

	static short ENCMethod;
	ENCMethod = 0;
	ENCMethod = Encrypted(F);
	/* ENCMethod ( 1 = Encrypted , 2 = Packed , 3 = NOT Encrypted) */

	CleanUp(0,1);

	if(ENCMethod == 1) // Encrypted
	{
		MessageBox (0, "The File You Are Trying To Encrypt Is Already Encrypted!" ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 2) // Packed
	{
		MessageBox (0, "The File You Are Trying To Encrypt Is Already Packed!" ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 3) // NOT Encrypted
	{
		if(EnCode(F,GetText(PasswordEdit_hWnd)) == 0)
		{
			CleanUp(0,0);

			if(IncodeMain(EncryptTemp,F) == 0)
			{
				MessageBox (0, "The File Was Successfully Encrypted." , TitleCaption, 0 + MB_ICONASTERISK);
				if(IsDlgButtonChecked(PasswordDialog_hWnd,105))
				{
					static short DeleteLoop;
					DeleteLoop = 0;

					while(DeleteLoop < Number_Of_Files)
					{
						DeleteLoop++;
						unlink(FileArray[DeleteLoop]);
						printf("Deleting %s",FileArray[DeleteLoop]);
					}
				}
				CleanUp(0,1);
			}
			else
				{
				Error("Encryption Failed. Error 2");
				CleanUp(1,1);
			}
		}
		else
			{
			Error("Encryption Failed. Error 3");
			CleanUp(1,1);
		}
	}
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int DecryptProcess(void)
{
	static short ENCMethod;
	ENCMethod = 0;
	ENCMethod = Encrypted(F);
	/* ENCMethod ( 1 = Encrypted , 2 = Packed , 3 = NOT Encrypted) */

	CleanUp(0,1);

	if(ENCMethod == 1) // Encrypted
	{
		RemoveFlag(F);
		CleanUp(0,1);

		if(DecodeMain(FileToChangeTemp,EncryptTemp) == 0)
		{
			CleanUp(0,0);
			if(DeCode(F,GetText(PasswordEdit_hWnd)) == 128)
			{
				MessageBox (0, "The File Was Successfully Decrypted." , TitleCaption, 0 + MB_ICONASTERISK);
			}
			CleanUp(0,1);
		}
		else
			{
			CleanUp(1,1);
			Error("Decryption Failed. Error 4.");
		}
		unlink(FileToChangeTemp);
	}

	if(ENCMethod == 2) //  Packed
	{
		static char xPath[257];
		static char xDrive[11];

		xPath[0] = '\0';
		xDrive[0] = '\0';

		static char SourceFilePath[257];
		/* Split Drive And Path Of SourceFileName And Set Then To (SourceFilePath) */
		_splitpath(F,xDrive,xPath,NULL,NULL);
		sprintf(SourceFilePath,"%s%s",xDrive,xPath);

		RemoveFlag(F);
		CleanUp(0,1);
		if(DecodeMain(FileToChangeTemp,EncryptTemp) == 0)
		{
			CleanUp(0,0);
			if(DeCode(PackBackupTemp,GetText(PasswordEdit_hWnd)) == 128)
			{
				CleanUp(0,1);
				if(UnPackFiles(PackBackupTemp,SourceFilePath))
				{
					MessageBox (0, "The File Was Successfully UnPacked." , TitleCaption, 0 + MB_ICONASTERISK);
					CleanUp(0,1);
					unlink(PackBackupTemp);
				}
			}
			CleanUp(0,1);
		}
		else
			{
			CleanUp(1,1);
			Error("Decryption Failed. Error 5.");
		}
		unlink(FileToChangeTemp);
		return(0);
	}

	if(ENCMethod == 3) // NOT Encrypted
	{
		MessageBox (0, "The File You Are Trying To Decrypt Is Not Encrypted!" , TitleCaption, 0 + MB_ICONASTERISK);
		CleanUp(0,1);
		return(0);
	}
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int ProcessInput(char *xInput)
{
	static short ENCMethod;
	ENCMethod = 0;
	//	  ENCMethod = Encrypted(F);
	/* ENCMethod ( 1 = Encrypted , 2 = Packed , 3 = NOT Encrypted) */

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		static char Extention[257];
		Extention[0] = '\0';
		_splitpath(xInput,NULL,NULL,NULL,Extention);

		if(FileEmpty(xInput) && (strcmp(Extention,".128") == 0) )
		{
			Clear_FileArray();
			Clear_FileSizeArray();
			Clear_ScanTemp();
			Clear_FileSizeArray_Temp();
			FileArray[0] = "*";

			if(PackFiles(xInput))
			{
				sprintf(F,"%s",xInput);
				MethodFlag = PACFlag;
				Encrypt = 1;
				Decrypt = 0;
				DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			}

			return 0;
		}

		MethodFlag = ENCFlag;
		sprintf(F,"%s",xInput);
		ENCMethod = Encrypted(F);

		if(ENCMethod == 1) // Encrypted
		{
			Encrypt = 0;
			Decrypt = 1;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			return 0;
		}

		if(ENCMethod == 2) //  Packed
		{
			Encrypt = 0;
			Decrypt = 1;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			return 0;
		}

		if(ENCMethod == 3) // NOT Encrypted
		{
			Encrypt = 1;
			Decrypt = 0;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			return 0;
		}

	}
	return 1;
}

/////////////////////////////////////////////////////////////////////


